﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Collections.ObjectModel;
using System.Web;



using ThinkGeo.MapSuite.Core;       // -----------MapSuiteCore
using ThinkGeo.MapSuite.WebEdition;  // -----------WebEdition

namespace CSSamples
{


  public class MyMarkerStyle : MarkerStyle
  {

    // Summary:
    //     Initialize a new instance of the ValueMarkerStyle class.
    public MyMarkerStyle() { }


    


    // Summary:
    //     Returns a collection of markers with a style applied based on the features
    //     that are passed in.
    //
    // Parameters:
    //   features:
    //     A collection of features used to create the markers.
    //
    // Returns:
    //     A collection of markers with a style applied based on the features that are
    //     passed in.
    public override Collection<Marker> GetMarkers(IEnumerable<Feature> features)
    {
      Collection<Marker> collectionMarkers = new Collection<Marker>();

      String path = "./theme/default/icons/Small/";

      foreach (Feature feature in features)
      {
        //Feature feature = features[idx];
        Marker marker = new Marker();
        marker.Position = feature.GetShape() as PointShape;

        StringBuilder contentHtml = new StringBuilder();
        if (feature.Id == "San Diego")
        {
          //marker.WebImage = new WebImage("../../theme/default/img/green.png", 21, 25);
          //marker.WebImage = new WebImage("../../theme/default/img/green.png");
          marker.WebImage = new WebImage("./theme/default/img/green.png");
          //marker.WebImage = new WebImage(path + feature.ColumnValues["Style"] + ".png");

          marker.WebImage.Text = "S";

        
          contentHtml.Append("<div style='padding:10px; font-size:10px; font-family:verdana;'>")
              .Append("San Diego is a city in CA")
              .Append("</div>");
        }
        else
        {
          //marker.WebImage = new WebImage("../../theme/default/img/blue.png", 21, 25);
          marker.WebImage = new WebImage("./theme/default/img/blue.png"); // , 35, 35);
          marker.WebImage.Text = "L";
          
          contentHtml.Append("<div style='padding:10px; font-size:12px; font-family:verdana;'>")
              .Append("LA is a city in CA")
              .Append("</div>");
        }

        
        //marker.WebImage.ImageHeight = 40;
        //marker.WebImage.ImageWidth = 40;


        //CustomPopup cPopup = new CustomPopup();
        CustomPopup cPopup = new CustomPopup(marker.Id, marker.Position, contentHtml.ToString(),
          0, 0, true, false);

        //cPopup.AutoPan = true;

        cPopup.AutoPan = true;
        cPopup.AutoSize = true;
        cPopup.BackgroundColor = GeoColor.StandardColors.LightYellow;
        cPopup.BorderColor = GeoColor.SimpleColors.BrightOrange;
        cPopup.IsVisible = false;

        marker.Popup = cPopup;

       marker.WebImage.FontColor = GeoColor.StandardColors.Black;

       marker.WebImage.FontStyle = new GeoFont("Arial Black", 16, DrawingFontStyles.Bold);
       marker.WebImage.TextOffsetX = 4F;
       marker.WebImage.TextOffsetY = 4F;

      //arker.WebImage.Text = "0";
        
        if (null != marker)
        {
          collectionMarkers.Add(marker);
        }
      } // end foreach    

      // Initialize tag list
      List<int> tagList = new List<int>();

      for (int idx = 0; idx < collectionMarkers.Count; idx++)
      {
        tagList.Add(0);
      }
      // Setting offset for overlapping markers

      for (int idx = 0; idx < collectionMarkers.Count; idx++)
      {
        Marker marker = collectionMarkers[idx];

        PointShape ptShapeMarker = marker.Position;

        Collection<Marker> clusterMarkers = new Collection<Marker>();

        for (int jnx = idx + 1; jnx < collectionMarkers.Count; jnx++)
        {
          if (tagList[jnx] == 0)
          {
            Marker candMarker = collectionMarkers[jnx];

            if (ptShapeMarker.Equal2D(candMarker.Position))
            {
              tagList[jnx] = 1;
              clusterMarkers.Add(candMarker);
            }
          }
        }// index = jnx

        double deltaDegree = 0.0;
        float radOffSet = 30.0f;
        if (clusterMarkers.Count >= 1)
        {
          deltaDegree = 360.0 / clusterMarkers.Count;
        }

        for (int knx = 0; knx < clusterMarkers.Count; knx++)
        {
          Marker clusterMarker = clusterMarkers[knx];
          double curDegree = deltaDegree * (knx);          

          float x = (float)Math.Cos(curDegree / 180 * Math.PI) * radOffSet;
          float y = (float)Math.Sin(curDegree / 180 * Math.PI) * radOffSet;

          clusterMarker.WebImage.ImageOffsetX = -x;
          clusterMarker.WebImage.ImageOffsetY = -y;

        }

       

      } // index = idx

      return collectionMarkers;
    }

  }
}